//
//  HSLanScanPortFinder.h
//  LAN Scan
//
//  Created by Kyle Hankinson on 2019-03-20.
//  Copyright © 2019 Smart Touch. All rights reserved.
//

#import <Foundation/Foundation.h>

NS_ASSUME_NONNULL_BEGIN

@class HSLanScanPortFinder;

typedef void (^HSLanScanPortFinderFoundEntryBlock)(HSLanScanPortFinder * portFinder);
typedef void (^HSLanScanPortFinderScanProgress)(NSUInteger completed, NSUInteger possible);
typedef void (^HSLanScanPortFinderScanFinishedBlock)(void);


@interface HSLanScanPortFinderResult : NSObject

- (NSUInteger) foundPort;
- (NSUInteger) foundAtDate;
- (NSString*)  ipAddress;
- (NSString*)  hostName;

@end

@interface HSLanScanPortFinder : NSObject

- (id) initWithPort: (NSUInteger) portToFind
    foundEntryBlock: (HSLanScanPortFinderFoundEntryBlock) foundEntryBlock
  scanProgressBlock: (HSLanScanPortFinderScanProgress) scanProgressBlock
      finishedBlock: (HSLanScanPortFinderScanFinishedBlock) finishedBlock;

- (void) beginScanning: (NSUInteger) timeoutPerServer;
- (void) stopScanning;

- (NSArray<HSLanScanPortFinderResult*>*) foundEntries;

@end

NS_ASSUME_NONNULL_END
